import java.awt.Canvas;
import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import java.awt.Toolkit;


public class mainFrame {

	private JFrame frmPeriodicSplines;
	private JPanel pGraph; 

	int order = 10; // number of reference points
    int datapoints = 1000; // number of datapoints for the interpolation
    int drawpoints = 1000;
   
    double integral = 0;
    public double deltaX = 0.5;
    boolean calculationError = false;

    double[][] m = new double[order-1][order-1];
    double[] y = new double[order-1];
    double[] x = new double[order-1];
    double[] t = new double[order-1];
    double[] yp = new double[datapoints];
    double[] xp = new double[datapoints];
    double[] x_k = new double[order+1];
    double[] y_k = new double[order + 1];
    double[] t_k = new double[order+1];
    double[] ax = new double[order+1];
    double[] bx = new double[order+1];
    double[] cx = new double[order+1];
    double[] dx = new double[order+1];
    double[] h = new double[order];

    double[] ay = new double[order + 1];
    double[] by = new double[order + 1];
    double[] cy = new double[order + 1];
    double[] dy = new double[order + 1];
    private JTextField[] tbs = new JTextField[order];
    private JTextField[] tbx = new JTextField[order];
    private JTextField textBoxY1;
    private JTextField textBoxY2;
    private JTextField textBoxY3;
    private JTextField textBoxY4;
    private JTextField textBoxY5;
    private JTextField textBoxY6;
    private JTextField textBoxX1;
    private JTextField textBoxX2;
    private JTextField textBoxX3;
    private JTextField textBoxX4;
    private JTextField textBoxX5;
    private JTextField textBoxX6;
    private JTextField textBoxY7;
    private JTextField textBoxY8;
    private JTextField textBoxY9;
    private JTextField textBoxY10;
    private JTextField textBoxX7;
    private JTextField textBoxX8;
    private JTextField textBoxX9;
    private JTextField textBoxX10;
    
    public class TPoint  {
		public float X;
        public float Y;	
	}

    public class myCanvas extends Canvas {
    	
		private static final long serialVersionUID = 1L;
		
		public void paint(Graphics g) { 		 			              
			  drawGraph(g, drawpoints, true);
		}
    }
    
   
    public boolean CalcParameters()
    {
    	int i, k;
        for (i = 0; i < order; i++)  // calculate a parameters
        {
            ax[i] = x_k[i];
            ay[i] = y_k[i];
        }
        ax[order] = x_k[1];
        ay[order] = y_k[1];
        for (i = 0; i < order-1; i++)
        {
            h[i] = t_k[i + 1] - t_k[i];
        }
        h[i] = h[0];
            
        // empty matrix for c parameters
        for (i = 0; i < order - 1; i++)
        {
            for (k = 0; k < order - 1; k++)
            {
                m[i][ k] = 0.0;
                y[i] = 0.0;
                x[i] = 0.0;
            }
        }

        // fill matrix for cx parameters
        for (i = 0; i < order - 1; i++)
        {
            if (i == 0)
            {
                m[i][0] = 2.0 * (h[0] + h[1]);
                m[i][1] = h[1];
            }
            else
            {
                m[i][ i - 1] = h[i];
                m[i][i] = 2.0 * (h[i] + h[i + 1]);
                if (i < order - 2)
                    m[i][i + 1] = h[i + 1];
            }
            if ((h[i] != 0.0) && (h[i + 1] != 0.0))
                y[i] = ((ax[i + 2] - ax[i + 1]) / h[i + 1] - (ax[i + 1] - ax[i]) / h[i]) * 3.0;
            else
                y[i] = 0.0;
         }
         m[0][order - 2] = h[0];
         m[order - 2][0] = h[0];

         TGauss gauss = new TGauss(order-1, m, y);

         if (gauss.Eliminate())
         {
        	 x = gauss.Solve();

             for (i = 1; i < order; i++)
             {
                 cx[i] = x[i - 1];
             }
             cx[0] = cx[order - 1];  // boundry condition for natural spline 
             for (i = 0; i < order; i++) // calculate b and d parameters
             {
                 if (h[i] != 0.0)
                 {
                     dx[i] = 1.0 / 3.0 / h[i] * (cx[i + 1] - cx[i]);
                     bx[i] = 1.0 / h[i] * (ax[i + 1] - ax[i]) - h[i] / 3.0 * (cx[i + 1] + 2 * cx[i]);
                 }
             }

             // empty matrix for cy parameters
             for (i = 0; i < order - 1; i++)
             {
                 for (k = 0; k < order - 1; k++)
                 {
                     m[i][k] = 0.0;
                     y[i] = 0.0;
                     x[i] = 0.0;
                 }
             }
             // fill matrix for c parameters
             for (i = 0; i < order - 1; i++)
             {
                 if (i == 0)
                 {
                     m[i][0] = 2.0 * (h[0] + h[1]);
                     m[i][1] = h[1];
                 }
                 else
                 {
                	 m[i][i - 1] = h[i];
                     m[i][i] = 2.0 * (h[i] + h[i + 1]);
                     if (i < order - 2)
                        m[i][i + 1] = h[i + 1];
                 }
                 if ((h[i] != 0.0) && (h[i + 1] != 0.0))
                    y[i] = ((ay[i + 2] - ay[i + 1]) / h[i + 1] - (ay[i + 1] - ay[i]) / h[i]) * 3.0;
                 else
                    y[i] = 0.0;
             }
             m[0][order - 2] = h[0];
             m[order - 2][0] = h[0];

             if (gauss.Eliminate())
             {
            	 x =gauss.Solve();

                 for (i = 1; i < order; i++)
                 {
                	 cy[i] = x[i - 1];
                 }
                 cy[0] = cy[order - 1];  // boundry condition for natural spline 
                 for (i = 0; i < order; i++) // calculate b and d parameters
                 {
                	 if (h[i] != 0.0)
                     {
                         dy[i] = 1.0 / 3.0 / h[i] * (cy[i + 1] - cy[i]);
                         by[i] = 1.0 / h[i] * (ay[i + 1] - ay[i]) - h[i] / 3.0 * (cy[i + 1] + 2 * cy[i]);
                     }
                 }
                 return true;
             }
             else
                 return false;
         }
         else
        	 return false;
    }
   

    public int Interpolate(int order, int resolution)
    {
        int i, k;
        double timestamp;
        for (i = 0; i < order - 1; i++)
        {
            for (k = 0; k < resolution; k++)
            {
                timestamp = (double)(k) / (double)(resolution) * h[i];
                xp[i * resolution + k] = ax[i] + bx[i] * (timestamp) + cx[i] * Math.pow(timestamp, 2) + dx[i] * Math.pow(timestamp, 3);
                yp[i * resolution + k] = ay[i] + by[i] * (timestamp) + cy[i] * Math.pow(timestamp, 2) + dy[i] * Math.pow(timestamp, 3);
            }
        }
        xp[i * resolution] = xp[0];
        yp[i * resolution] = yp[0];
        return i * resolution;
    }

    
   private void calculate()
   {
	   int i;
       boolean isError = false;
       
      for (i = 0; i < order; i++)
      {
          if (tbs[i].getText() != "")
          {
        	  y_k[i] = Double.parseDouble(tbs[i].getText());
              x_k[i] = Double.parseDouble(tbx[i].getText());
          }
          else
          {
              y_k[i] = 0.0;
              x_k[i] = 0.0;
          }
      }
      if (CalcParameters())
      {
    	  drawpoints = Interpolate(order, datapoints / order);           
      }
      else
    	  JOptionPane.showMessageDialog(frmPeriodicSplines,"Matrix calculattion");      
   }

   
   public void drawGraph(Graphics g, int maxPoints, boolean doClear)
   {
       TPoint p1, p2;
       int j;
       double maxTime = -1.0;
       double maxVal = -1.0;
       double minVal = 1.0;
       double scalefactor;
       boolean drawCeroline;
       for (j = 0; j < maxPoints - 1; j++)
       {
          if (maxTime < xp[j])
        	  maxTime = xp[j];
          if (maxVal < yp[j])
        	  maxVal = yp[j];
          if (minVal > yp[j])
        	  minVal = yp[j];        
       }
       maxTime = maxTime * 1.05;
       maxTime = maxTime * 1.05;
       if (minVal < 0)
       {
           if (maxVal > 0)
           {
               if (maxVal > Math.abs(minVal))
                   scalefactor = pGraph.getHeight() / maxVal / 2.2;
               else
                   scalefactor = pGraph.getHeight() / Math.abs(minVal) / 2.2;
           }
           else
               scalefactor = 5.0;
           drawCeroline = true;
       }
       else
       {
           scalefactor = pGraph.getHeight() / (maxVal) / 1.1;
           drawCeroline = false;
       }
       p1 = new TPoint();
       p2 = new TPoint();
       if (doClear)
       	g.clearRect(0, 0, pGraph.getWidth(), pGraph.getHeight());
      
       g.setColor(new Color(0, 0, 255));
       if (drawCeroline)
       {
           p1.X = 0;
           p1.Y = (pGraph.getHeight() / 2);
           p2.X = pGraph.getWidth();
           p2.Y = (pGraph.getHeight() / 2);
           g.setColor(new Color(0, 0, 0));
           g.drawLine((int)Math.round(p1.X),(int)Math.round(p1.Y),(int)Math.round( p2.X),(int)Math.round(p2.Y)); 
       }
       g.setColor(new Color(0, 0, 255));
       if (maxTime > 0) // draw interpolated graph
       {
           for (j = 0; j < maxPoints - 1; j++)
           {     
               p1.X = (int)Math.round(xp[j] * pGraph.getWidth() / (double)maxTime);
               p2.X = (int)Math.round(xp[j + 1] * pGraph.getWidth() / (double)maxTime);
               if (drawCeroline)
               {
                   p1.Y = (pGraph.getHeight() / 2) - (int)Math.round(yp[j] * scalefactor);
                   p2.Y = (pGraph.getHeight() / 2) - (int)Math.round(yp[j + 1] * scalefactor);
               }
               else
               {
                   p1.Y = (pGraph.getHeight() - (int)Math.round(yp[j] * scalefactor));
                   p2.Y = (pGraph.getHeight() - (int)Math.round(yp[j + 1] * scalefactor));
               }
               g.drawLine((int)Math.round(p1.X),(int)Math.round(p1.Y),(int)Math.round( p2.X),(int)Math.round(p2.Y)); 
           }
           g.setColor(new Color(255, 0, 0));
           for (j = 0; j < order; j++) // mark reference points
           {
        	   p1.X = (int)Math.round(x_k[j] * pGraph.getWidth() / (double)maxTime);
               if (drawCeroline)
                   p1.Y = (pGraph.getHeight() / 2) - (int)Math.round(y_k[j] * scalefactor);
               else
                   p1.Y = (pGraph.getHeight() - (int)Math.round(y_k[j] * scalefactor));
               g.drawOval((int)Math.round(p1.X-2), (int)Math.round(p1.Y-2), 4, 4);
           }
       }
   }
	


	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					mainFrame window = new mainFrame();
					window.frmPeriodicSplines.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public mainFrame() {
		int i;
		initialize();
		tbs[0] = textBoxY1;
		tbs[1] = textBoxY2;
		tbs[2] = textBoxY3;
		tbs[3] = textBoxY4;
		tbs[4] = textBoxY5;
		tbs[5] = textBoxY6;
		tbs[6] = textBoxY7;
		tbs[7] = textBoxY8;
		tbs[8] = textBoxY9;
		tbs[9] = textBoxY10;
				
		tbx[0] = textBoxX1;
		tbx[1] = textBoxX2;
		tbx[2] = textBoxX3;
		tbx[3] = textBoxX4;
		tbx[4] = textBoxX5;
		tbx[5] = textBoxX6;
		tbx[6] = textBoxX7;
		tbx[7] = textBoxX8;
		tbx[8] = textBoxX9;
		tbx[9] = textBoxX10;
	
		
		 // init some sample values
        y_k[0] = 6.0;
        y_k[1] = 9.5;
        y_k[2] = 7.0;
        y_k[3] = 4.0;
        y_k[4] = 3.0;
        y_k[5] = 5.0;
        y_k[6] = 6.0;
        y_k[7] = 4.0;
        y_k[8] = 2.0;
        y_k[9] = 6.0;

        x_k[0] = 9.0;
        x_k[1] = 6.0;
        x_k[2] = 3.0;
        x_k[3] = 2.0;
        x_k[4] = 4.0;
        x_k[5] = 5.0;
        x_k[6] = 3.0;
        x_k[7] = 1.0;
        x_k[8] = 4.0;
        x_k[9] = 9.0;
        
     // 1timestamp to t value
        for (i = 1; i <= order; i++)
        {
            t_k[i - 1] = deltaX * (double)i;
        }
       
       for (i = 0; i < order; i++)
       {
    	
           tbs[i].setText(Double.toString(y_k[i]));
           tbx[i].setText(Double.toString(x_k[i]));

       }
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmPeriodicSplines = new JFrame();
		frmPeriodicSplines.setTitle("Periodic splines");
		frmPeriodicSplines.setIconImage(Toolkit.getDefaultToolkit().getImage(mainFrame.class.getResource("/Ressource/Icon.png")));
		frmPeriodicSplines.setBounds(100, 100, 450, 300);
		frmPeriodicSplines.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmPeriodicSplines.setBounds(100, 100, 840, 536);
		frmPeriodicSplines.getContentPane().setLayout(null);
		pGraph = new JPanel();
		final Canvas canvas = new myCanvas();
		canvas.setBackground(Color.WHITE);
		pGraph.addComponentListener(new ComponentAdapter() {
			@Override
			public void componentResized(ComponentEvent arg0) {
				canvas.setBounds(0, 0, pGraph.getWidth(), pGraph.getHeight());
			}
		});
		pGraph.setBackground(Color.WHITE);
		pGraph.setBounds(10, 11, 800, 393);
		frmPeriodicSplines.getContentPane().add(pGraph);
		pGraph.add(canvas);
		pGraph.setLayout(null);
		
		textBoxY1 = new JTextField();
		textBoxY1.setColumns(10);
		textBoxY1.setBounds(49, 416, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY1);
		
		textBoxY2 = new JTextField();
		textBoxY2.setColumns(10);
		textBoxY2.setBounds(110, 416, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY2);
		
		textBoxY3 = new JTextField();
		textBoxY3.setColumns(10);
		textBoxY3.setBounds(171, 416, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY3);
		
		textBoxY4 = new JTextField();
		textBoxY4.setColumns(10);
		textBoxY4.setBounds(232, 415, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY4);
		
		textBoxY5 = new JTextField();
		textBoxY5.setColumns(10);
		textBoxY5.setBounds(293, 416, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY5);
		
		textBoxY6 = new JTextField();
		textBoxY6.setColumns(10);
		textBoxY6.setBounds(354, 416, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY6);
		
		textBoxX1 = new JTextField();
		textBoxX1.setColumns(10);
		textBoxX1.setBounds(49, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX1);
		
		textBoxX2 = new JTextField();
		textBoxX2.setColumns(10);
		textBoxX2.setBounds(110, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX2);
		
		textBoxX3 = new JTextField();
		textBoxX3.setColumns(10);
		textBoxX3.setBounds(171, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX3);
		
		textBoxX4 = new JTextField();
		textBoxX4.setColumns(10);
		textBoxX4.setBounds(232, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX4);
		
		textBoxX5 = new JTextField();
		textBoxX5.setColumns(10);
		textBoxX5.setBounds(293, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX5);
		
		textBoxX6 = new JTextField();
		textBoxX6.setColumns(10);
		textBoxX6.setBounds(354, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX6);
		
		textBoxY7 = new JTextField();
		textBoxY7.setColumns(10);
		textBoxY7.setBounds(415, 416, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY7);
		
		textBoxY8 = new JTextField();
		textBoxY8.setColumns(10);
		textBoxY8.setBounds(476, 416, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY8);
		
		textBoxY9 = new JTextField();
		textBoxY9.setColumns(10);
		textBoxY9.setBounds(537, 415, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY9);
		
		textBoxY10 = new JTextField();
		textBoxY10.setColumns(10);
		textBoxY10.setBounds(598, 415, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxY10);
		
		textBoxX7 = new JTextField();
		textBoxX7.setColumns(10);
		textBoxX7.setBounds(415, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX7);
		
		textBoxX8 = new JTextField();
		textBoxX8.setColumns(10);
		textBoxX8.setBounds(476, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX8);
		
		textBoxX9 = new JTextField();
		textBoxX9.setColumns(10);
		textBoxX9.setBounds(537, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX9);
		
		textBoxX10 = new JTextField();
		textBoxX10.setColumns(10);
		textBoxX10.setBounds(598, 457, 51, 30);
		frmPeriodicSplines.getContentPane().add(textBoxX10);
		
		JLabel lblNewLabel = new JLabel("Y");
		lblNewLabel.setFont(new Font("Tahoma", Font.PLAIN, 14));
		lblNewLabel.setBounds(20, 423, 46, 14);
		frmPeriodicSplines.getContentPane().add(lblNewLabel);
		
		JLabel lblX = new JLabel("X");
		lblX.setFont(new Font("Tahoma", Font.PLAIN, 14));
		lblX.setBounds(20, 464, 46, 14);
		frmPeriodicSplines.getContentPane().add(lblX);
		
		JButton btCalc = new JButton("Calculate");
		btCalc.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				calculate();
				canvas.repaint();
			}
		});
		btCalc.setBounds(698, 415, 112, 72);
		frmPeriodicSplines.getContentPane().add(btCalc);
	}
}
